=== debian/changelog ===
linphone (5.0.37-6) unstable; urgency=medium

  * Import upstream fix for crashes on PUBLISH messages without
    SIP-Etags (Closes: #1021043).

 -- Dennis Filder <d.filder@web.de>  Sun, 02 Oct 2022 16:53:48 +0000

linphone (5.0.37-5) unstable; urgency=medium

  * Release to unstable.

 -- Bernhard Schmidt <berni@debian.org>  Mon, 12 Sep 2022 20:25:04 +0200

linphone (5.0.37-4) experimental; urgency=medium

  * Use DEB_HOST_GNU_TYPE instead of DEB_HOST_MULTIARCH to fix FTBFS on i386

 -- Bernhard Schmidt <berni@debian.org>  Mon, 05 Sep 2022 23:27:18 +0200

linphone (5.0.37-3) experimental; urgency=medium

  * Rebuild against libmediastreamer2 with shlibs

 -- Bernhard Schmidt <berni@debian.org>  Mon, 05 Sep 2022 21:08:36 +0200

linphone (5.0.37-2) experimental; urgency=medium

  * Move doxygen from Build-Depends-Indep to Build-Depends

 -- Bernhard Schmidt <berni@debian.org>  Thu, 18 Aug 2022 09:14:19 +0200

linphone (5.0.37-1) experimental; urgency=medium

  [ Dennis Filder ]
  * New upstream release 5.0.37
  * Newly enabled features:
    - Advanced IM
    - LDAP support

 -- Bernhard Schmidt <berni@debian.org>  Tue, 11 Jan 2022 20:57:48 +0100
